$item-font-size: rem(16px);
$item-font-size-small: rem(14px);
$item-line-height-small: rem(32px);
$item-line-height-large: rem(36px);
$text-line-height: rem(20px);
$nav-variables: (
  mobile-spacing: rem(10px),
  desktop-spacing: rem(6px),
  mobile-height: rem(40px),
  desktop-height: rem(32px),
  icon-size: rem(20px),
  item-line-height: rem(40px),
);
@function nav($variable) {
  @return map-get($nav-variables, $variable);
}

$nav-animation-variables: (
  items-to-stagger: 12,
  stagger-interval: 50,
);
@function nav-animation($variable) {
  @return map-get($nav-animation-variables, $variable);
}

@mixin nav-item-attributes {
  @include unstyled-button;
  font-size: $item-font-size;
  font-weight: 600;
  line-height: $item-line-height-large;
  display: flex;
  flex-grow: 1;
  align-items: flex-start;
  max-width: 100%;
  padding: 0 spacing(tight);
  margin: 0 spacing(tight);
  border-radius: var(--p-border-radius-base);
  color: var(--p-text);
  text-decoration: none;
  text-align: left;
  padding-left: spacing() - spacing(extra-tight);
  padding-right: spacing(extra-tight);

  &:hover {
    background: var(--p-background-hovered);
    color: var(--p-text);
    text-decoration: none;
  }

  @include focus-ring;

  &.keyFocused {
    @include focus-ring($style: 'focused');
    background: var(--p-background-hovered);
    color: var(--p-text);
    text-decoration: none;
  }

  &:active,
  &:active:hover {
    color: var(--p-text);
    background-color: var(--p-background-pressed);
    @include no-focus-ring;
  }

  @include breakpoint-after(nav-min-window-corrected()) {
    font-size: $item-font-size;
    font-weight: 600;
    line-height: $item-line-height-small;
  }
  &::-moz-focus-inner {
    border: 0;
  }
}

@mixin nav-item-icon-attributes {
  // hardcoding this variable for now because we need to rip out all instances
  // of filter() eventually but can't for this one right now. The value is the
  // equivalent value for filter('icon').
  --p-filter-icon: brightness(0) saturate(100%) invert(36%) sepia(13%)
    saturate(137%) hue-rotate(169deg) brightness(95%) contrast(87%);
  --p-filter-icon-action-primary: brightness(0) saturate(100%) invert(20%)
    sepia(59%) saturate(5557%) hue-rotate(162deg) brightness(95%) contrast(101%);
  --p-filter-icon-on-interactive: brightness(0) saturate(100%) invert(100%);

  @include recolor-icon(
    $fill-color: var(--p-icon),
    $filter-color: var(--p-filter-icon)
  );
  flex-shrink: 0;
  align-self: flex-start;
  width: nav(icon-size);
  height: nav(icon-size);
  margin-top: nav(mobile-spacing);
  margin-right: spacing();
  margin-bottom: nav(mobile-spacing);
  @include breakpoint-after(nav-min-window-corrected()) {
    margin-top: nav(desktop-spacing);
    margin-right: spacing();
    margin-bottom: nav(desktop-spacing);
  }

  .Item:hover &,
  .Item.keyFocused & {
    @include recolor-icon(
      $fill-color: var(--p-icon),
      $filter-color: var(--p-filter-icon)
    );
  }

  .Item-selected &,
  .Item-selected:hover &,
  .subNavigationActive &,
  .subNavigationActive:hover &,
  .Item-selected.keyFocused & {
    @include recolor-icon(
      $fill-color: var(--p-action-primary),
      $filter-color: var(--p-filter-icon-action-primary)
    );
  }

  // The regular nav items are wrapped in polaris icon components which add
  // the styles we're missing which causes the channel items to shift down
  svg {
    display: block;
  }
}

@mixin nav-list-item-attributes {
  position: relative;
  display: flex;
  flex-wrap: wrap;
  .RollupSection &,
  .SecondaryNavigation & {
    opacity: 1;
  }
  @for $i from 1 through nav-animation(items-to-stagger) {
    &:nth-child(#{$i}) {
      animation-delay: #{($i - 1) * nav-animation(stagger-interval)}ms;
    }
  }
}

@mixin nav-item-text-attributes {
  flex: 1 1 auto;
  margin-top: nav(mobile-spacing);
  margin-bottom: nav(mobile-spacing);
  line-height: $text-line-height;
  font-size: $item-font-size-small;

  @include breakpoint-after(nav-min-window-corrected()) {
    margin-top: nav(desktop-spacing);
    margin-bottom: nav(desktop-spacing);
  }

  @include breakpoint-before(nav-min-window-corrected()) {
    font-size: rem(15px);
    line-height: rem(19px);
  }
}

@keyframes fade-in {
  0% {
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}

@mixin usermenu-section-attributes {
  position: relative;
  margin-top: spacing();
  &::before {
    content: '';
    position: absolute;
    top: spacing(tight) * -1;
    left: 0;
    display: block;
    width: 100%;
    height: 1px;
    background-color: var(--p-surface-neutral);
  }
}
